MantisBT
Mantis Bug Tracker Workflow

View Issue Details Jump to Notes ] Related Changesets ] Issue History ] Print ]
IDProjectCategoryView StatusDate SubmittedLast Update
0025133Open CASCADE[OCCT] OCCT:Visualizationpublic2014-08-06 19:042014-11-11 12:58
Reportersan 
Assigned Tobugmaster 
PriorityimmediateSeveritycrash 
StatusclosedResolutionfixed 
PlatformOSOS Version
Product Version[OCCT] 6.7.0 
Target Version[OCCT] 6.8.0Fixed in Version[OCCT] 6.8.0 
Summary0025133: TKOpenGl - Crash on closing a view containing presentations with capping
DescriptionThe problem is reproduced with the current OCCT Git master and vc10 64-bit binaries (both debug and release).

When a 3D view containing a presentation with capping is closed, an application crashes.

Quick analysis with MS VisualStudio debugger showed that there is an endless recursion:

...
     TKernel.dll!Handle_Standard_Transient::EndScope()  Line 54	C++
     TKOpenGl.dll!OpenGl_CappingPlaneResource::Release(const OpenGl_Context * theContext)  Line 62	C++
     
TKOpenGl.dll!OpenGl_Context::ReleaseDelayed()  Line 1918	C++
     TKOpenGl.dll!OpenGl_Context::~OpenGl_Context()  Line 139	C++
     TKOpenGl.dll!OpenGl_Context::`vector deleting destructor'()  + 0x7d bytes	C++
     TKernel.dll!Standard_Transient::Delete()  Line 72 + 0x30 bytes	C++
     TKernel.dll!Handle_Standard_Transient::EndScope()  Line 54	C++
     TKOpenGl.dll!OpenGl_CappingPlaneResource::Release(const OpenGl_Context * theContext)  Line 62	C++
     
TKOpenGl.dll!OpenGl_Context::ReleaseDelayed()  Line 1918	C++
     TKOpenGl.dll!OpenGl_Context::~OpenGl_Context()  Line 139	C++

...
Steps To ReproduceScenario 1:
pload ALL
test bugs vis bug24901
vclose View1


Scenario 2:
pload ALL
box b 1 1 1
vdisplay b
vclipplane create pln1
vclipplane set pln1 object b
vclipplane change pln1 capping on
vclose
TagsNo tags attached.
Test case numberbugs vis(004) bug25133_1, bug25133_2
Attached Files

- Relationships

-  Notes
(0031053)
git (administrator)
2014-08-22 19:53

Branch CR25133 has been created by san.

SHA-1: 2ef08c8a810dc8356d8d27a0a657b947d33a1839


Detailed log of new commits:

Author: san
Date: Fri Aug 22 19:53:00 2014 +0400

    0025133: TKOpenGl - Crash on closing a view containing presentations with capping
    OpenGl_Element destruction and resource deallocation methods now accept
    a pointer to OpenGl_Context instead of a handle to avoid double deletion
    of the context.
(0031054)
san (developer)
2014-08-22 19:54

Branch CR25133 is ready for reviewing.
(0031061)
git (administrator)
2014-08-25 12:57

Branch CR25133 has been updated forcibly by san.

SHA-1: 6cc6fc4b1a9e6f9cf661c2b65c4e06135e6b9cc7
(0031062)
kgv (developer)
2014-08-25 13:03

Please test the patch.
(0031082)
apv (tester)
2014-08-26 11:41

Dear BugMaster,

Branch CR25133 was compiled on Linux and Windows platforms.

There are following compilation errors (on Linux):
http://jenkins-test-02.nnov.opencascade.com/user/mnt/my-views/view/CR25133/job/mnt-CR25133-master_build_occt_linux/1/parsed_console/ [^]
   ../../../../src/OpenGl/OpenGl_CappingPlaneResource.cxx:59: error: prototype for ‘void OpenGl_CappingPlaneResource::Release(OpenGl_Context*)’ does not match any in class ‘OpenGl_CappingPlaneResource’
   ../../../../inc/OpenGl_CappingPlaneResource.hxx:53: error: candidate is: virtual void OpenGl_CappingPlaneResource::Release(const OpenGl_Context*)

There are following compilation errors (on Windows):
http://jenkins-test-02.nnov.opencascade.com/user/mnt/my-views/view/CR25133/job/mnt-CR25133-master_build_occt_windows/1/parsed_console/ [^]
   ..\..\..\src\OpenGl\OpenGl_CappingPlaneResource.cxx(60): error C2511: 'void OpenGl_CappingPlaneResource::Release(OpenGl_Context *)' : overloaded member function not found in 'OpenGl_CappingPlaneResource'
   ..\..\..\src\OpenGl\OpenGl_Font.cxx(58): error C2511: 'void OpenGl_Font::Release(OpenGl_Context *)' : overloaded member function not found in 'OpenGl_Font'
   ..\..\..\src\OpenGl\OpenGl_FrameBuffer.cxx(112): error C2511: 'void OpenGl_FrameBuffer::Release(OpenGl_Context *)' : overloaded member function not found in 'OpenGl_FrameBuffer'
   ..\..\..\src\OpenGl\OpenGl_LineAttributes.cxx(521): error C2511: 'void OpenGl_LineAttributes::Release(OpenGl_Context *)' : overloaded member function not found in 'OpenGl_LineAttributes'
   ..\..\..\src\OpenGl\OpenGl_PointSprite.cxx(53): error C2511: 'void OpenGl_PointSprite::Release(OpenGl_Context *)' : overloaded member function not found in 'OpenGl_PointSprite'
   ..\..\..\src\OpenGl\OpenGl_ShaderObject.cxx(129): error C2511: 'void OpenGl_ShaderObject::Release(OpenGl_Context *)' : overloaded member function not found in 'OpenGl_ShaderObject'
   ..\..\..\src\OpenGl\OpenGl_ShaderProgram.cxx(1249): error C2511: 'void OpenGl_ShaderProgram::Release(OpenGl_Context *)' : overloaded member function not found in 'OpenGl_ShaderProgram'
   ..\..\..\src\OpenGl\OpenGl_Texture.cxx(119): error C2511: 'void OpenGl_Texture::Release(OpenGl_Context *)' : overloaded member function not found in 'OpenGl_Texture'
   ..\..\..\src\OpenGl\OpenGl_TextureBufferArb.cxx(58): error C2511: 'void OpenGl_TextureBufferArb::Release(OpenGl_Context *)' : overloaded member function not found in 'OpenGl_TextureBufferArb'
   ..\..\..\src\OpenGl\OpenGl_VertexBuffer.cxx(73): error C2511: 'void OpenGl_VertexBuffer::Release(OpenGl_Context *)' : overloaded member function not found in 'OpenGl_VertexBuffer'
(0031104)
git (administrator)
2014-08-26 17:23

Branch CR25133 has been updated forcibly by san.

SHA-1: bd33ff40c6d2e9dcbb44f511f4d545a4a098f6cc
(0031105)
san (developer)
2014-08-26 17:25

Old OpenGl headers replaced with the correct modified ones.
(0031106)
san (developer)
2014-08-26 17:26

Branch CR25133 ready for testing.
(0031109)
git (administrator)
2014-08-26 18:18

Branch CR25133 has been updated by mkv.

SHA-1: 5f8ccbed6584b7ae7cd094b9e6200dc9add03497


Detailed log of new commits:

Author: mkv
Date: Tue Aug 26 18:18:09 2014 +0400

    Test cases for issue CR25133

(0031126)
mkv (tester)
2014-08-27 16:25
edited on: 2014-08-27 16:26

Dear BugMaster,
Branch CR25133 from occt git-repository (and master from products git-repository) was compiled on Linux and Windows platforms and tested.
SHA-1: 5f8ccbed6584b7ae7cd094b9e6200dc9add03497

Number of compiler warnings:

occt component :
Linux: 15 (15 on master)
Windows: 0 (0 on master)

products component :
Linux: 11 (11 on master)
Windows: 1 (1 on master)

Regressions/Differences:
No regressions/differences

Testing cases:
http://occt-tests/CR25133-master-occt/Debian60-64/bugs/vis/bug25133_1.html [^]
http://occt-tests/CR25133-master-occt/Windows-32-VC10/bugs/vis/bug25133_1.html [^]
bugs vis(004) bug25133_1: OK

http://occt-tests/CR25133-master-occt/Debian60-64/bugs/vis/bug25133_2.html [^]
http://occt-tests/CR25133-master-occt/Windows-32-VC10/bugs/vis/bug25133_2.html [^]
bugs vis(004) bug25133_2: OK

Testing on Linux:
occt component :
Total MEMORY difference: 353233644 / 353263524
Total CPU difference: 46752.170000000166 / 44482.54000000008
products component :
Total MEMORY difference: 110220336 / 110151972
Total CPU difference: 18126.739999999965 / 17587.009999999977

Testing on Windows:
occt component :
Total MEMORY difference: 240908636 / 241085560
Total CPU difference: 46232.640625 / 40204.328125
products component :
Total MEMORY difference: 66556616 / 66446108
Total CPU difference: 15525.84375 / 15948.671875

There are no differences in images found by testdiff.

(0031135)
mkv (tester)
2014-08-28 11:07

Dear san,
It was detected that Voxel QT sample is not compiled

http://jenkins-test-03.nnov.opencascade.com:8080/user/mnt/my-views/view/CR25133/job/mnt-CR25133-master_build_occt_qt_samples_window/1/parsed_console/ [^]
1>src\VoxelClient_VisDrawer.cxx(121): error C2259: 'VoxelClient_VisDrawer::VisElement' : cannot instantiate abstract class

Please correct imediatly
(0031142)
git (administrator)
2014-08-28 11:55

Branch CR25133 has been updated forcibly by san.

SHA-1: d9e70ee3b3577f69970315772ed3f9b67221ccc8
(0031143)
san (developer)
2014-08-28 11:56

Voxel QT sample corrected in branch CR25133, ready for testing.
(0031148)
mkv (tester)
2014-08-28 12:58

Dear BugMaster,
Voxel QT sample is compiled without errors.
(0031471)
git (administrator)
2014-09-08 15:51

Branch CR25133 has been deleted by inv.

SHA-1: d9e70ee3b3577f69970315772ed3f9b67221ccc8

- Related Changesets
occt: master 10b9c7df
Timestamp: 2014-08-28 07:55:06
Author: san
Committer: bugmaster
Details ] Diff ]
0025133: TKOpenGl - Crash on closing a view containing presentations with capping

OpenGl_Element destruction and resource deallocation methods now accept
a pointer to OpenGl_Context instead of a handle to avoid double deletion
of the context.
mod - samples/qt/VoxelDemo/src/VoxelClient_VisDrawer.cxx Diff ] File ]
mod - src/OpenGl/OpenGl_AspectFace.cxx Diff ] File ]
mod - src/OpenGl/OpenGl_AspectFace.hxx Diff ] File ]
mod - src/OpenGl/OpenGl_AspectLine.cxx Diff ] File ]
mod - src/OpenGl/OpenGl_AspectLine.hxx Diff ] File ]
mod - src/OpenGl/OpenGl_AspectMarker.cxx Diff ] File ]
mod - src/OpenGl/OpenGl_AspectMarker.hxx Diff ] File ]
mod - src/OpenGl/OpenGl_AspectText.cxx Diff ] File ]
mod - src/OpenGl/OpenGl_AspectText.hxx Diff ] File ]
mod - src/OpenGl/OpenGl_CappingPlaneResource.cxx Diff ] File ]
mod - src/OpenGl/OpenGl_CappingPlaneResource.hxx Diff ] File ]
mod - src/OpenGl/OpenGl_Element.hxx Diff ] File ]
mod - src/OpenGl/OpenGl_Flipper.cxx Diff ] File ]
mod - src/OpenGl/OpenGl_Flipper.hxx Diff ] File ]
mod - src/OpenGl/OpenGl_Font.cxx Diff ] File ]
mod - src/OpenGl/OpenGl_Font.hxx Diff ] File ]
mod - src/OpenGl/OpenGl_FrameBuffer.cxx Diff ] File ]
mod - src/OpenGl/OpenGl_FrameBuffer.hxx Diff ] File ]
mod - src/OpenGl/OpenGl_GraduatedTrihedron.cxx Diff ] File ]
mod - src/OpenGl/OpenGl_GraduatedTrihedron.hxx Diff ] File ]
mod - src/OpenGl/OpenGl_GraphicDriver_7.cxx Diff ] File ]
mod - src/OpenGl/OpenGl_Group.cxx Diff ] File ]
mod - src/OpenGl/OpenGl_LineAttributes.cxx Diff ] File ]
mod - src/OpenGl/OpenGl_LineAttributes.hxx Diff ] File ]
mod - src/OpenGl/OpenGl_PointSprite.cxx Diff ] File ]
mod - src/OpenGl/OpenGl_PointSprite.hxx Diff ] File ]
mod - src/OpenGl/OpenGl_PrimitiveArray.cxx Diff ] File ]
mod - src/OpenGl/OpenGl_PrimitiveArray.hxx Diff ] File ]
mod - src/OpenGl/OpenGl_Resource.hxx Diff ] File ]
mod - src/OpenGl/OpenGl_ShaderObject.cxx Diff ] File ]
mod - src/OpenGl/OpenGl_ShaderObject.hxx Diff ] File ]
mod - src/OpenGl/OpenGl_ShaderProgram.cxx Diff ] File ]
mod - src/OpenGl/OpenGl_ShaderProgram.hxx Diff ] File ]
mod - src/OpenGl/OpenGl_StencilTest.cxx Diff ] File ]
mod - src/OpenGl/OpenGl_StencilTest.hxx Diff ] File ]
mod - src/OpenGl/OpenGl_Structure.cxx Diff ] File ]
mod - src/OpenGl/OpenGl_Text.cxx Diff ] File ]
mod - src/OpenGl/OpenGl_Text.hxx Diff ] File ]
mod - src/OpenGl/OpenGl_Texture.cxx Diff ] File ]
mod - src/OpenGl/OpenGl_Texture.hxx Diff ] File ]
mod - src/OpenGl/OpenGl_TextureBufferArb.cxx Diff ] File ]
mod - src/OpenGl/OpenGl_TextureBufferArb.hxx Diff ] File ]
mod - src/OpenGl/OpenGl_Trihedron.cxx Diff ] File ]
mod - src/OpenGl/OpenGl_Trihedron.hxx Diff ] File ]
mod - src/OpenGl/OpenGl_VertexBuffer.cxx Diff ] File ]
mod - src/OpenGl/OpenGl_VertexBuffer.hxx Diff ] File ]
mod - src/OpenGl/OpenGl_View.cxx Diff ] File ]
mod - src/ViewerTest/ViewerTest_OpenGlCommands.cxx Diff ] File ]

- Issue History
Date Modified Username Field Change
2014-08-06 19:04 san New Issue
2014-08-06 19:04 san Assigned To => apl
2014-08-06 19:06 san Description Updated View Revisions
2014-08-06 19:07 san Status new => assigned
2014-08-06 19:19 san Description Updated View Revisions
2014-08-07 13:39 apl Steps to Reproduce Updated View Revisions
2014-08-07 13:40 apl Steps to Reproduce Updated View Revisions
2014-08-22 19:53 git Note Added: 0031053
2014-08-22 19:54 san Note Added: 0031054
2014-08-22 19:54 san Assigned To apl => kgv
2014-08-22 19:54 san Status assigned => resolved
2014-08-25 12:57 git Note Added: 0031061
2014-08-25 13:03 kgv Note Added: 0031062
2014-08-25 13:03 kgv Assigned To kgv => bugmaster
2014-08-25 13:03 kgv Status resolved => reviewed
2014-08-25 13:03 kgv Steps to Reproduce Updated View Revisions
2014-08-25 13:05 kgv Product Version => 6.7.0
2014-08-25 18:16 apv Assigned To bugmaster => apv
2014-08-26 11:41 apv Note Added: 0031082
2014-08-26 11:42 apv Assigned To apv => san
2014-08-26 11:42 apv Status reviewed => assigned
2014-08-26 17:23 git Note Added: 0031104
2014-08-26 17:25 san Note Added: 0031105
2014-08-26 17:25 san Status assigned => resolved
2014-08-26 17:26 san Note Added: 0031106
2014-08-26 17:26 san Assigned To san => bugmaster
2014-08-26 17:26 san Status resolved => reviewed
2014-08-26 17:35 mkv Assigned To bugmaster => mkv
2014-08-26 18:18 git Note Added: 0031109
2014-08-27 16:25 mkv Note Added: 0031126
2014-08-27 16:26 mkv Note Edited: 0031126 View Revisions
2014-08-27 16:26 mkv Test case number => bugs vis(004) bug25133_1, bug25133_2
2014-08-27 16:26 mkv Assigned To mkv => bugmaster
2014-08-27 16:26 mkv Status reviewed => tested
2014-08-28 11:07 mkv Note Added: 0031135
2014-08-28 11:07 mkv Assigned To bugmaster => san
2014-08-28 11:07 mkv Priority normal => immediate
2014-08-28 11:07 mkv Status tested => feedback
2014-08-28 11:55 git Note Added: 0031142
2014-08-28 11:56 san Note Added: 0031143
2014-08-28 11:56 san Assigned To san => bugmaster
2014-08-28 11:56 san Status feedback => reviewed
2014-08-28 12:11 mkv Assigned To bugmaster => mkv
2014-08-28 12:58 mkv Note Added: 0031148
2014-08-28 12:58 mkv Assigned To mkv => bugmaster
2014-08-28 12:58 mkv Status reviewed => tested
2014-08-29 15:32 bugmaster Changeset attached => occt master 10b9c7df
2014-08-29 15:32 bugmaster Status tested => verified
2014-08-29 15:32 bugmaster Resolution open => fixed
2014-09-08 15:51 git Note Added: 0031471
2014-11-11 12:45 aiv Fixed in Version => 6.8.0
2014-11-11 12:58 aiv Status verified => closed


Copyright © 2000 - 2020 MantisBT Team
Powered by Mantis Bugtracker